/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */
 
 #include "controlBDD.h"
 
 
 ControlBDD *ControlBDD::instance = 0;
 
 ControlBDD::ControlBDD(string hostname, string dbname, string login, string pass):hostname(hostname),dbname(dbname),login(login),pass(pass) {
	 mysqlpp::Connection connexion(true);
 }
 
ControlBDD* ControlBDD::getInstance() {
	 if (instance == NULL)
		 instance = new ControlBDD(HOSTNAME,BASE,LOGIN,PASS);
	 
	 return instance;
 }
	 
 /*Getters et Setters*/
string ControlBDD::getHostname(void) {
	return hostname;
}
void ControlBDD::setHostname(string hostname) {
	this->hostname = hostname;
}

string ControlBDD::getDbname(void) {
	return dbname;
}
void ControlBDD::setDbname(string dbname) {
	this->dbname = dbname;
}

string ControlBDD::getLogin(void) {
	return login;
}
void ControlBDD::setLogin(string login) {
	this->login = login;
}

string ControlBDD::getPass(void) {
	return pass;
}
void ControlBDD::setPass(string pass) {
	this->pass = pass;
}

/*Ouverture de la connexion à la base de donnée MySQL*/
bool ControlBDD::connexionDb(void) {
	bool res;
	
	/*Connexion à la base de données*/
	res = connexion.connect(getDbname().c_str(),getHostname().c_str(),getLogin().c_str(),getPass().c_str()); //seg fault
	
	if (res == true)
	{
		//cout<<"Connexion établie a la base"<<endl;
		return true;
	}
		else
		{
			//cout<<"Connexion a la base echoue"<<endl;
			return false;
		}
}

/*Execution d'une requete de type select et qui place les résultats dans un vecteur*/
vector<string>* ControlBDD::selectInDb(string requete) {
	
	vector<string> *elts = new vector<string>() ;
	mysqlpp::Result resultat;
	/*On cree et initialse la requete*/
	try
	{
		mysqlpp::Query query = connexion.query();
		query << requete;
	
	/*On execute la requete et stock le resultat dans un Result Set*/
		 resultat = query.store();
	}
	
	catch (BadQuery& er) {
        cerr << "Error: " << er.what() << endl;
            }
    catch (BadConversion& er) {
        cerr << "Error: " << er.what() << "\"." << endl
            << "retrieved data size: " << er.retrieved
            << " actual data size: " << er.actual_size << endl;
        
    }
    catch (exception& er) {
        cerr << "Error: " << er.what() << endl;
        
    }

	mysqlpp::Row row; //On crée un Row pr lire chaque ligne du Result Set
	
	/*On parcours l'ensemble du Result Set*/
	Result::iterator parcour;
	for(parcour = resultat.begin();parcour != resultat.end();parcour++)
	{
		/*On initialise la ligne*/
		row = *parcour;
		int nbChamps = row.size(); // Récupération du nombre de champs
		int it;
		/*Pour chaque champ, on récupére sa valeur et on l'insere dans le vecteur*/
		for( it=0;it<nbChamps;it++)
		{
			string valeur(row[it]); //Place le resultat de row.at(it) dans une string
			elts->push_back(valeur); //insertion
		}
	}
	return elts;
}
	
/*Fermeture de la connexion à la base de données*/
void ControlBDD::closeConnexionDb(void) {
	connexion.close();
	//cout<<"Fermeture de la connexion à la base"<<endl;
}
