#include "hqi.hpp"


void HQI::init()
{
  started=true;
  stop=false;
  state=0;
  state_sauv=0;
}


short HQI::getStarted()
{
  return started;
}


void HQI::setStarted (bool started)
{
  this->started=started;
}


void HQI::stopper(connexion &c,K8055 &k,config &cfg)
{
  stop=true;
  state=0;
  state_sauv=state;
  k.change_state(c, cfg.OUTHQI,state,"ALERT: temperature trop leve: hqi");
}


void HQI::noStart (connexion &c)
{
  stop=true;
  c.insert_log("hqi arret");
}

void HQI::start ()
{
  double dif;
  time_t rawtime;
//check the current time  
  time ( &rawtime );
  dif = difftime (rawtime,timer);
//if the timer of the HQI is passed, start the HQI  
  if( (dif/60) > cfg.STARTHQI) 
    started=false;
}
  

void HQI::forceState(short forcedState,connexion &c,K8055 &k,config &cfg)
{
  if (state!=forcedState)
    {
      state_sauv=state;
      state=forcedState;
      k.change_state(c, cfg.OUTHQI,state,"HQI forced");
    }
}

void HQI::changeState (short state,connexion &c,K8055 &k,config &cfg)
{
  this->state=state;
  state_sauv=state;
  k.change_state(c, cfg.OUTHQI,state,"HQI");
}

void HQI::changing (short st,double temperature,connexion & c,K8055& k,config & cfg)
{
//if the state is forced
  if (cfg.forced_hqi!=0)   
    forceState(cfg.forced_hqi-1,c,k,cfg);
  
    
  else
    {
      if (state!=state_sauv)
    	changeState(state_sauv,c,k,cfg);      
//if the temp is to high and the HQI is running      
      if (temperature > cfg.THQI && stop==false && state==1)
	stopper(c,k,cfg);

      if (state!=st && started==false && stop==false)
// HQI do not start if t > THQI	
	if (temperature > cfg.THQI)
	  noStart (c);
	else changeState (st,c,k,cfg);
	
    }
  
  // wait starthqi (user defined) before starting hqi 
  if (started== true)
    start();
}
