#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <K8055DLL.h>

int main(int argc, char *argv[])
{
	long ana1;
	long ana2;
	int i;
	long swmask;
	long cnt1;
	long cnt2;

	if (OpenDevice(0) < 0)
	{
		fputs("Couldn't find k8055 card!\n", stderr);
		exit(1);
	}

	for (i = 1; i <= 8; i++)
	{
		SetDigitalChannel(i);
		usleep(200);
	}
	ClearAllDigital();
	for (i = 1; i <= 8; i++)
	{
		SetDigitalChannel(i);
		usleep(200);
		ClearDigitalChannel(i);
	}

	for (i = 0; i <= 255; i += 3)
	{
		OutputAnalogChannel(1, i);
	}
	for (i = 0; i <= 255; i += 3)
	{
		OutputAnalogChannel(2, i);
	}

	usleep(1000);

	ReadAllAnalog(&ana1, &ana2);
	printf("Analog Input 1 = %lu, Analog Input 2 = %lu\n", ana1, ana2);

	fputs("Input Switches: ", stdout);
	swmask = ReadAllDigital();

	for (i = 1; i <= 5; i++)
	{
		if (swmask & (1 << (i - 1)))
		{
			printf("SW%d ", i);
		}
	}
	putchar('\n');

	cnt1 = ReadCounter(1);
	cnt2 = ReadCounter(2);

	printf("Counter 1 = %lu, Counter 2 = %lu\n", cnt1, cnt2);

	ClearAllDigital();
	ClearAllAnalog();

	CloseDevice();

	exit(0);
}

